config/routes.rb
Rails.application.routes.draw do
  devise_for :users, controllers: { sessions: 'users/sessions' }

  namespace :admin do
    get '/', to: 'reports#index'
    resources :users
    resources :properties
    resources :reports
    resources :bids, only: [:index, :edit, :update, :destroy]
  end

  root 'home#index'
  get 'about' => 'home#about'
  get 'contact' => 'home#contact'
  get 'price' => 'home#price'
  get 'order' => 'home#order'
  post 'orders' => 'home#create_order'

end

app/models/report.rb
class Report < ActiveRecord::Base

  validates :timestamp, presence: true

  belongs_to :result

  has_many :muttons
  accepts_nested_attributes_for :result
  accepts_nested_attributes_for :muttons, :allow_destroy => true

  scope :find_by_daily, -> daily { where(timestamp: Time.zone.now.beginning_of_day..Time.zone.now) if daily.present? }

  def total_rowspan
    self.muttons.count
  end

  def total_kg
    total = 0
    self.muttons.each do |mutton|
      total += mutton.total_kg.to_i
    end
    total
  end

  def total_box
    total = 0
    self.muttons.each do |mutton|
      total += mutton.total_box.to_i
    end
    total
  end

end

app/controllers/admin/reports_controller.rb
class Admin::ReportsController < Admin::AdminController
  before_action :set_report, only: [:show, :edit, :update, :destroy]

  PER_PAGE = 20

  def index
    @reports = Report.includes(:muttons).page(params[:page]).per(PER_PAGE).order(id: :desc)
    @reports = @reports.find_by_daily(params[:time_scope])
    respond_to do |format|
      format.html
      format.pdf do
        render pdf: "reoprts-#{Time.now.strftime('%Y-%m-%d')}",
               orientation: 'Landscape'
      end
    end
  end

  def show
  end

  def edit
  end

  def new
    @report = Report.new
    @result = @report.build_result
    Property.all.each do |property|
      @report.muttons.build(property_id: property.id)
    end
  end

  def destroy
    @report.destroy
    respond_to do |format|
      format.html { redirect_to admin_reports_path, notice: 'Laporan berhasil dihapus.' }
    end
  end

  def update
    respond_to do |format|
      if @report.update(report_params)
        format.html { redirect_to admin_reports_path, notice: 'Laporan berhasil diubah.' }
      else
        format.html { render :edit }
      end
    end
  end

  def create
    @report = Report.new(report_params)
    respond_to do |format|
      if @report.save
        format.html { redirect_to admin_reports_path, notice: 'Laporan berhasil dibuat.' }
      else
        @result = @report.build_result
        format.html { render :new }
      end
    end
  end

  private
    def set_report
      @report = Report.find(params[:id])
    end

    def report_params
      params.require(:report).permit(
        :timestamp,
        :time,
        :result_attributes => [:total_meat, :total_karkas],
        muttons_attributes: [
          :id,
          :total_box,
          :total_kg,
          :property_id
          ]
        )
    end

end

app/views/admin/reports/_form.html.erb
<!-- Main Content -->
<div class="container-fluid">
	<div class="side-body">
		<div class="page-title">
			<span class="title">Buat Laporan Baru</span>
		</div>
		<div class="row">
			<div class="col-xs-12">
				<div class="card">
					<div class="card-body">
						<%= form_for [:admin, @report], { :class => 'form-horizontal' } do |form| %>
						<% if @report.errors.any? %>
						<div class="alert fresh-color alert-danger" role="alert">
							<ul>
								<% @report.errors.full_messages.each do |message| %>
								<li>
									<strong><%= message %></strong>
								</li>
								<% end %>
							</ul>
						</div>
						<% end %>
						<div class="sub-title">Tanggal</div>
						<div class="form-group">
							<div class='input-group date' id='datetimepicker1'>
								<%= form.text_field :timestamp, class: 'form-control', placeholder: 'Time' %>
								<span class="input-group-addon">
									<span class="glyphicon glyphicon-calendar"></span>
								</span>
							</div>
						</div>
						<div class="sub-title">Jumlah Karkas dan Berat Awal Daging</div>
						<%= form.fields_for :result, @result do |result_form| %>
								<div class="form-group">
									<div class="col-xs-12">
										<div class="sub-title">Jumlah Karkas</div>
									</div>
									<div class="col-xs-12">
										<%= result_form.number_field :total_karkas, min: 0, class: 'form-control', placeholder: 'Jumlah Karkas'  %>
									</div>
								</div>
								<div class="clearfix"></div>
								<br>
								<div class="form-group">
									<div class="col-xs-12">
										<div class="sub-title">Berat Awal</div>
									</div>
									<div class="col-xs-12">
										<%= result_form.number_field :total_meat, min: 0, class: 'form-control', placeholder: 'Berat Awal Daging'  %>
									</div>
								</div>
						<% end %>
						<div class="clearfix"></div>
						<br>
						<div class="panel panel-default">
							 <div class="panel-heading" role="tab" id="headingOne">
								 <h4 class="panel-title">
									 <a role="button" data-toggle="collapse" data-parent="#accordion" href="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
										 <span class="glyphicon glyphicon-list" aria-hidden="true"></span>&nbsp; Input Data Boning
									 </a>
								 </h4>
							 </div>
							 <div id="collapseOne" class="panel-collapse collapse in" role="tabpanel" aria-labelledby="headingOne">
									<div class="panel-body">
										<div class="clearfix"></div>
										<%= form.fields_for :muttons do |ff| %>
											<% unless ff.object.id.nil? %>
												<%= ff.hidden_field :id, :value => ff.object.id %>
											<% end %>
											<%= ff.hidden_field :property_id, :value => ff.object.property_id %>
											<div class="sub-title"><%= ff.object.try(:property).try(:name).try(:capitalize) %> (<%= ff.object.try(:property).try(:code) %>)</div>
											<div class="form-group">
												<label class="col-sm-1">Jumlah Kg</label>
												<div class="col-sm-4">
													<%= ff.number_field :total_kg, min: 0, class: 'form-control', placeholder: 'Jumlah Kg'  %>
												</div>
											</div>
											<div class="form-group">
												<label class="col-sm-1 control-label">Jumlah Dus</label>
												<div class="col-sm-4">
													<%= ff.number_field :total_box, min: 0, class: 'form-control', placeholder: 'Jumlah Dus'  %>
												</div>
											</div>
											<div class="clearfix"></div>
										<% end %>
							 	 	</div>
							 </div>
						</div>
						<div class="clearfix"></div>
						<%= link_to 'Back', admin_reports_path, class: "btn btn-sm btn-default" %>
						<button type="submit" class="btn btn-sm btn-info">Submit</button>
						<% end %>
					</div>
				</div>
			</div>
		</div>
	</div>
	<script type="text/javascript">
		$(function () {
			$('#datetimepicker1').datetimepicker({format: "YYYY-MM-DD HH:mm", defaultDate: moment().format("YYYY-MM-DD HH:mm:ss"), useCurrent: true});
		});
		$('#collapseOne').collapse("hide");
	</script>

app/views/admin/reports/edit.html.erb
<%= render 'form' %>

app/views/admin/reports/index.html.erb
<!-- Main Content -->
<div class="container-fluid">
    <div class="side-body">
        <div class="row">
            <div class="col-xs-12">
                <div class="card">
                    <div class="card-header">
                        <div class="card-title">
                          <div class="title">Laporan</div>
                        </div>
                        <div class="pull-right card-action">
                          <%= link_to "Laporan Baru", new_admin_report_path, class: 'btn btn-sm btn-info', method: 'get' %>
                          <%= link_to "Download PDF ", admin_reports_path(:time_scope => params[:time_scope], :format => :pdf ), class: 'btn btn-sm btn-info', method: 'get' %>
                        </div>
                    </div>
                    <div class="card-body">
                      <% if notice %>
                        <div class="alert alert-success" role="alert">
                          <strong><%= notice %></strong></a>
                        </div>
                      <% end %>
                      <div class="panel panel-default">
                         <div class="panel-heading" role="tab" id="headingOne">
                           <h4 class="panel-title">
                             <a role="button" data-toggle="collapse" data-parent="#accordion" href="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
                               <span class="glyphicon glyphicon-list" aria-hidden="true"></span>&nbsp;Pencarian
                             </a>
                           </h4>
                         </div>
                         <div id="collapseOne" class="panel-collapse collapse in" role="tabpanel" aria-labelledby="headingOne">
                           <%= form_tag admin_reports_path, :method => :get, :html => { :class => 'form-horizontal' }  do %>
                              <div class="panel-body">
                                 <div class="sub-title">Time Scope :</div>
                                 <div>
                                   <select name="time_scope">
                                      <% if params[:time_scope] == 'daily' %>
                                      <option value="all">------</option>
                                      <option selected="selected" value="daily">Daily Report</option>
                                      <% else %>
                                        <option value="all" selected="selected">------</option>
                                        <option value="daily">Daily Report</option>
                                      <% end %>
                                    </select>
                                 </div>
                                 <div class="clearfix"></div>
                                 <div class="sub-title"></div>
                                 <div>
                                     <%= submit_tag 'Cari', class: 'btn btn-default' %>
                                     <%= link_to 'Reset', admin_reports_path, class: 'btn btn-default' %>
                                 </div>
                           </div>
                           <% end %>
                         </div>
                      </div>
                       <table class="table table-bordered">
                           <thead>
                             <tr>
                               <th width="2%" bgcolor="#9adbf9">No</th>
                               <th width="10%" bgcolor="#9adbf9">Waktu</th>
                               <th width="10%" bgcolor="#9adbf9">Nama</th>
                               <th width="8%" bgcolor="#9adbf9">Satuan Kg</th>
                               <th width="8%" bgcolor="#9adbf9">Satuan Dus</th>
                               <th width="5%" bgcolor="#9adbf9">Tipe</th>
                               <th width="8%" bgcolor="#9adbf9">Boning (Kg)</th>
                               <th width="8%" bgcolor="#9adbf9">Boning (Dus)</th>
                               <th width="8%" bgcolor="#9adbf9">Berat Awal</th>
                               <th width="8%" bgcolor="#9adbf9">Karkas</th>
                               <th colspan="2" width="5%" bgcolor="#9adbf9"></th>
                             </tr>
                           </thead>
                           <tbody>
                             <% @reports.each_with_index do |report, index_num| %>
                               <tr>
                                 <td rowspan="<%= report.total_rowspan + 1 %>">
                                   <%= index_num + 1 %>
                                 </td>
                                 <td rowspan="<%= report.total_rowspan + 1 %>">
                                   <%= report.timestamp.strftime('%d-%m-%Y %H:%M') %>
                                 </td>
                                 <td style="border:none;padding: 0px;">
                                 </td>
                                 <td style="border:none;padding: 0px;">
                                 </td>
                                 <td style="border:none;padding: 0px;">
                                 </td>
                                 <td style="border:none;padding: 0px;">
                                 </td>
                                 <td rowspan="<%= report.total_rowspan + 1 %>">
                                   <%= report.total_kg %>
                                 </td>
                                 <td rowspan="<%= report.total_rowspan + 1 %>">
                                   <%= report.total_box %>
                                 </td>
                                 <td rowspan="<%= report.total_rowspan + 1 %>">
                                   <%= report.result.total_meat %>
                                 </td>
                                 <td rowspan="<%= report.total_rowspan + 1 %>">
                                   <%= report.result.total_karkas %>
                                 </td>
                                 <td rowspan="<%= report.total_rowspan + 1 %>">
                                   <%= link_to 'Edit', edit_admin_report_path(report), class: "btn btn-sm btn-warning" %>
                                 </td>
                                 <td rowspan="<%= report.total_rowspan + 1 %>">
                                   <%= link_to 'Hapus', [:admin, report], method: :delete, data: { confirm: 'Apakah anda yakin ?' }, class: "btn btn-sm btn-danger" %>
                                 </td>
                               </tr>
                                 <% report.muttons.each_with_index do |mutton, index| %>
                                     <tr>
                                       <td><%= mutton.property.try(:name) %> - (<%= mutton.property.try(:code) %>)</td>
                                       <td><%= mutton.total_kg.to_i %></td>
                                       <td><%= mutton.total_box.to_i %></td>
                                       <td><%= mutton.property.try(:parent) %></td>
                                     </tr>
                                 <% end %>
                             <% end %>
                           </tbody>
                       </table>
                       <%= paginate @reports %>

                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<script type="text/javascript">
  $('#collapseOne').collapse("hide");
</script>

app/views/admin/reports/index.pdf.erb
<!DOCTYPE html>
<html>
<head>
  <title>Meat</title>
  <%= wicked_pdf_stylesheet_link_tag "pdf"%>
</head>
<body class="flat-blue">
  <div class="app-container">
    <div class="row content-container">
      <!-- Main Content -->
      <div class="container-fluid">
          <div class="side-body">
              <div class="row">
                  <div class="col-xs-12">
                      <div class="card">
                          <div class="card-body">
                             <table class="table table-bordered">
                                 <thead>
                                   <tr>
                                     <th width="2%" bgcolor="#9adbf9">No</th>
                                     <th width="10%" bgcolor="#9adbf9">Waktu</th>
                                     <th width="10%" bgcolor="#9adbf9">Nama</th>
                                     <th width="8%" bgcolor="#9adbf9">Satuan Kg</th>
                                     <th width="8%" bgcolor="#9adbf9">Satuan Dus</th>
                                     <th width="5%" bgcolor="#9adbf9">Tipe</th>
                                     <th width="8%" bgcolor="#9adbf9">Boning (Kg)</th>
                                     <th width="8%" bgcolor="#9adbf9">Boning (Dus)</th>
                                     <th width="8%" bgcolor="#9adbf9">Berat Awal</th>
                                     <th width="8%" bgcolor="#9adbf9">Karkas</th>
                                   </tr>
                                 </thead>
                                 <tbody>
                                   <% @reports.each_with_index do |report, index_num| %>
                                     <tr>
                                       <td rowspan="<%= report.total_rowspan + 1 %>">
                                         <%= index_num + 1 %>
                                       </td>
                                       <td rowspan="<%= report.total_rowspan + 1 %>">
                                         <%= report.timestamp.strftime('%d-%m-%Y') %>
                                       </td>
                                       <td style="border:none;padding: 0px;">
                                       </td>
                                       <td style="border:none;padding: 0px;">
                                       </td>
                                       <td style="border:none;padding: 0px;">
                                       </td>
                                       <td style="border:none;padding: 0px;">
                                       </td>
                                       <td rowspan="<%= report.total_rowspan + 1 %>">
                                         <%= report.total_kg %>
                                       </td>
                                       <td rowspan="<%= report.total_rowspan + 1 %>">
                                         <%= report.total_box %>
                                       </td>
                                       <td rowspan="<%= report.total_rowspan + 1 %>">
                                         <%= report.result.total_meat %>
                                       </td>
                                       <td rowspan="<%= report.total_rowspan + 1 %>">
                                         <%= report.result.total_karkas %>
                                       </td>
                                     </tr>
                                       <% report.muttons.each_with_index do |mutton, index| %>
                                           <tr>
                                             <td><%= mutton.property.try(:name) %> - (<%= mutton.property.try(:code) %>)</td>
                                             <td><%= mutton.total_kg.to_i %></td>
                                             <td><%= mutton.total_box.to_i %></td>
                                             <td><%= mutton.property.try(:parent) %></td>
                                           </tr>
                                       <% end %>
                                   <% end %>
                                 </tbody>
                             </table>
                          </div>
                      </div>
                  </div>
              </div>
          </div>
      </div>
    </div>
  </div>
</body>
</html>

app/views/admin/reports/new.html.erb
<%= render 'form' %>